import 'dart:collection';

import 'package:meta/meta.dart';

export 'groupby.dart';
export 'indexed_list.dart';

@experimental
abstract class DataTable<T> extends ListBase<T> {
  final List<T> _inner;

  DataTable(this._inner);

  @override
  T operator [](int index) => _inner[index];

  @override
  void operator []=(int index, T value) => _inner[index] = value;

  @override
  int get length => _inner.length;

  @override
  set length(int value) => _inner.length = value;

  List<List> get columns;

  // TODO describe
}

abstract class Column<T> implements List<T> {
  String get name;
  set name(String value);
}

@experimental
class TableCol<P, T> extends ListBase<T> implements Column<T> {
  @override
  String name;

  final List<P> _inner;

  final T Function(P element) getter;
  final void Function(P element, T value) setter;

  TableCol(this.name, this._inner, {required this.getter, required this.setter});

  @override
  T operator [](int index) => getter(_inner[index]);

  @override
  void operator []=(int index, T value) => setter(_inner[index], value);

  @override
  int get length => _inner.length;

  @override
  set length(int value) => _inner.length = value;
}
