import 'package:grizzly/grizzly.dart';
import 'package:grizzly/src/utils/comap.dart';

extension IntMatExt on List<List<int>> {}

extension IntMatViewExt on Iterable<Iterable<int>> {
  bool isEqual(Iterable<Iterable<num>> v) {
    final iter1 = iterator;
    final iter2 = v.iterator;
    while (iter1.moveNext() && iter2.moveNext()) {
      if (!iter1.current.isEqual(iter2.current)) {
        return false;
      }
    }
    return true;
  }

  bool assertEqual(Iterable<Iterable<num>> v) {
    final iter1 = iterator;
    final iter2 = v.iterator;
    int i = 0;
    while (iter1.moveNext() && iter2.moveNext()) {
      try {
        iter1.current.assertEqual(iter2.current);
      } on AssertionError catch (e) {
        throw AssertionError('$i:${e.message}');
      }
      i++;
    }
    return true;
  }

  bool isEqualVector(Iterable<num> v) {
    for (final row in this) {
      if (!row.isEqual(v)) return false;
    }
    return true;
  }

  bool isEqualScalar(num v) {
    for (final row in this) {
      if (!row.isEqualScalar(v)) return false;
    }
    return true;
  }

  Iterable<int> dot([Iterable<Iterable<num>>? other]) => comapEq(
      this, other ?? this, (Iterable<int> a, Iterable<num> b) => a.dot(b));
}
