class MeanReducer {
  int _n = 0;
  double _mean = 0;

  double get mean => _mean;

  void consume(num sample) {
    _n++;
    _mean += (sample - _mean) / _n;
  }

  void merge(MeanReducer other) {
    if (other._n == 0) return;
    if (_n == 0) {
      _n = other._n;
      _mean = other._mean;
      return;
    }

    final delta = other._mean - _mean;
    _n = _n + other._n;
    _mean += delta * other._n / _n;
  }
}

class VarianceReducer {
  int _n = 0;
  double _mean = 0;
  double _m2 = 0;

  double get variance => _m2 / (_n - 1);

  void consume(num sample) {
    _n++;
    final delta = sample - _mean;
    _mean += delta / _n;
    _m2 += delta * (sample - _mean);
  }

  void merge(VarianceReducer other) {
    if (other._n == 0) return;
    if (_n == 0) {
      _n = other._n;
      _mean = other._mean;
      _m2 = other._m2;
      return;
    }

    _n += other._n;
    final delta = other._mean - _mean;
    _mean += delta * other._n / _n;
    _m2 += other._m2 + delta * delta * _n * other._n;
  }
}